-- Perhatian, ekstensi ini dibuat oleh Zain Muhammad Haikal. Warning, warning, and warning up.

require "import"
import "android.widget.*"
import "android.view.*"
import "java.io.InputStreamReader"
import "java.io.BufferedReader"
import "java.net.HttpURLConnection"
import "java.net.URL"
import "cjson"
import "android.net.Uri"

local function ucapkan(text)
  service.speak(text)
end

local function translateTextToIndonesian(text, callback)
  local url = "https://translate.google.com/m?sl=en&tl=id&hl=" .. Locale.getDefault().getLanguage() .. "&q=" .. Uri.encode(text)
  
  Http.get(url, function(status, result)
    if status == 200 then
      local translation = result:match('<div class="result%-container">([^<]+)</div>')
      if translation ~= nil then
        callback(nil, translation)
      else
        callback("Terjemahan tidak tersedia.", nil)
      end
    else
      callback("Tidak dapat melakukan terjemahan.", nil)
    end
  end)
end

local function getWeather(city, callback)
  local url = URL("https://wttr.in/" .. city .. "?format=j1")
  local connection = url.openConnection()
  connection.setRequestMethod("GET")
  local responseCode = connection.getResponseCode()

  if responseCode == 200 then
    local inputStream = connection.getInputStream()
    local reader = BufferedReader(InputStreamReader(inputStream))
    local response = StringBuilder()
    local line

    while true do
      line = reader.readLine()
      if not line then break end
      response.append(line)
    end

    reader.close()
    inputStream.close()
    local responseString = response.toString()
    local jsonResponse = cjson.decode(responseString)

    if jsonResponse and jsonResponse.current_condition then
      local description = jsonResponse.current_condition[1].weatherDesc[1].value
      local temperature = jsonResponse.current_condition[1].temp_C
      callback(nil, description, temperature)
    else
      callback("Format respons tidak valid", nil, nil)
    end
  else
    callback("Gagal mendapatkan data cuaca", nil, nil)
  end
end

local function showWeather(city, description, temperature)
  local textToTranslate = string.format("Cuaca di %s: %s\nSuhu: %.1f°C", city, description, temperature)
  
  translateTextToIndonesian(textToTranslate, function(err, translatedText)
    if err then
      service.postSpeak(200, err)
      resultView.setText(err)
    else
      service.postSpeak(200, translatedText)
      resultView.setText(translatedText)
    end
  end)
end

layout = {
  LinearLayout;
  orientation = "vertical";
  layout_width = "match_parent";
  layout_height = "match_parent";
  backgroundColor = "#000000";
  {
    LinearLayout;
    orientation = "horizontal";
    layout_width = "match_parent";
    layout_height = "wrap_content";
    {
      TextView;
      text = "Cek Cuaca";
      id = "titleTextView";
      textColor = "#FFFFFF";
      textSize = "20sp";
      gravity = "center";
      layout_width = "0dp";
      layout_weight = "1";
      layout_height = "wrap_content";
    };
    {
      TextView;
      text = "Dibuat oleh Zain Muhammad Haikal, Dipesan oleh Ahmad Fadilah senggol ah bosku mantap";
      id = "createdByTextView";
      textColor = "#FFFFFF";
      textSize = "14sp";
      gravity = "center";
      layout_width = "0dp";
      layout_weight = "1";
      layout_height = "wrap_content";
    };
  };
  {
    EditText;
    hint = "Masukkan Nama Kota";
    id = "cityInput";
    layout_width = "match_parent";
    layout_height = "wrap_content";
  };
  {
    Button;
    text = "Cek Cuaca";
    id = "getWeatherButton";
    onClick = function(view)
      local city = cityInput.getText().toString()

      if city ~= "" then
        getWeather(city, function(err, description, temperature)
          if err then
            service.postSpeak(200, err)
            resultView.setText(err)
          else
            showWeather(city, description, temperature)
          end
        end)
      else
        service.postSpeak(200, "Masukkan nama kota yang valid")
      end
    end;
    layout_width = "match_parent";
    layout_height = "wrap_content";
  };
  {
    TextView;
    id = "resultView";
    textColor = "#FFFFFF";
    layout_width = "match_parent";
    layout_height = "wrap_content";
  };
}

dlg = LuaDialog()
dlg.setView(loadlayout(layout))
dlg.show()